@echo off

color 1F

chcp 1252 > nul

set CHEMIN=f:\Wamp\bin\apache\apache2.4.12
set DIRNAME=Certificats

REM ----------------------------------------
REM   Chemin et Variables d'environnements  
REM ----------------------------------------

:Top
set PATH=%CHEMIN%\bin;%PATH%

set OPENSSL_CONF=.\openssl.cnf

REM ------------------
REM   Certificat SSL  
REM ------------------

:Menu
cls
@echo Certificats SSL
@echo ---------------
@echo.
@echo Chemin     = %CHEMIN%
@echo Rpertoire = %DIRNAME%
@echo.
@echo -------------------------------------------------------   -------------------------------------------------------
@echo     Autorit de certification (CA)                            Autre
@echo -------------------------------------------------------   -------------------------------------------------------
@echo a : Cration d'un Nombre Pseudo-Alatoire         (RND)   1 : chemin vers apache 2.2.29
@echo b : Cration de la clef prive sans mot de passe  (KEY)   2 : chemin vers apache 2.4.12
@echo c : Cration de la demande de signature           (CSR)
@echo d : Cration du certificat auto-sign             (CRT)   3 : transfert du certificat vers Apache.
@echo e : Visualisation du certificat                           4 : remise  zro du rpertoire
@echo f : Clef Public                                   (PBC)   9 : fin
@echo.
@echo -------------------------------------------------------   -------------------------------------------------------
@echo     Certificat Serveur
@echo -------------------------------------------------------
@echo m : Cration d'un Nombre Pseudo-Alatoire         (RND)
@echo n : Cration de la clef prive sans mot de passe  (KEY)
@echo o : Cration de la demande de signature           (CSR)
@echo p : Cration du certificat par le CA              (CRT)
@echo q : Conversion certificat PEM vers PFX            (PFX)
@echo r : Visualisation du certificat CLIENT PFX
@echo s : Clef public                                   (PBC)
@echo.
@echo -----------------------------------------------------------------------------------------------------------------
@echo.

set choix=
set /p choix=Votre choix ?

if not '%choix%'=='' set choix=%choix:~0,1%

if '%choix%' == 'a' goto :CaA
if '%choix%' == 'b' goto :CaB
if '%choix%' == 'c' goto :CaC

if '%choix%' == 'd' goto :CaD
if '%choix%' == 'e' goto :CaE
if '%choix%' == 'f' goto :CaF

REM ---------------------------

if '%choix%' == 'm' goto :SrA
if '%choix%' == 'n' goto :SrB
if '%choix%' == 'o' goto :SrC

if '%choix%' == 'p' goto :SrD
if '%choix%' == 'q' goto :SrE
if '%choix%' == 'r' goto :SrF

if '%choix%' == 's' goto :SrG

REM ---------------------------

if '%choix%' == '1' goto :Cas1
if '%choix%' == '2' goto :Cas2
if '%choix%' == '3' goto :Cas3

if '%choix%' == '4' goto :Cas4
if '%choix%' == '9' goto :Cas9

REM --------------------
REM   Aucune slection  
REM --------------------

@echo.
@echo Veuillez recommencer !
@echo.
goto :menu

REM **************************************
REM *                                    *
REM *     Authorit de Certification     *
REM *                                    *
REM **************************************
REM
REM -----------------------------------------
REM   Cration d'un Nombre Pseudo-Alatoire  
REM -----------------------------------------

:CaA
cls

if EXIST %DIRNAME%\Private\Ca.rnd  del %DIRNAME%\Private\Ca.rnd

openssl rand  -out %DIRNAME%/Private/Ca.rnd  -base64  1257

@echo.
pause 
goto :Menu

REM ------------------------------------------------
REM   Cration d'une clef prive sans mot de passe  
REM ------------------------------------------------

:CaB
cls

if EXIST %DIRNAME%\Private\Ca.key  del %DIRNAME%\Private\Ca.key

openssl genrsa  -out %DIRNAME%/Private/Ca.key  -rand %DIRNAME%/Private/Ca.rnd  4096

@echo.
pause 
goto :Menu

REM -----------------------------------------------------
REM   Cration de la demande de signature du certificat  
REM -----------------------------------------------------

:CaC
cls

if EXIST %DIRNAME%\Cacerts\Ca.csr  del %DIRNAME%\Cacerts\Ca.csr

openssl req  -new  -sha256  -key %DIRNAME%/Private/Ca.key  -out %DIRNAME%/Cacerts/Ca.csr  -subj "/C=FR/ST=Aquitaine/L=Montignac/O=Artemus & Cie/CN=Artemus & Cie"

@echo.
pause 
goto :Menu

REM ----------------------------------------
REM   Cration du CA certificat auto-sign  
REM ----------------------------------------

:CaD
cls

if EXIST %DIRNAME%\Cacerts\Ca.crt  del %DIRNAME%\Cacerts\Ca.crt

openssl x509  -req  -days 4383  -sha256  -in %DIRNAME%/Cacerts/Ca.csr  -signkey %DIRNAME%/Private/Ca.key  -out %DIRNAME%/Cacerts/Ca.crt

@echo.
pause 
goto :Menu

REM -------------------------------
REM   Visualisation du certificat  
REM -------------------------------

:CaE
cls

openssl x509  -in %DIRNAME%/Cacerts/Ca.crt  -noout  -text

@echo.
pause 
goto :Menu

REM ---------------
REM   Clef Public  
REM ---------------

:CaF
cls

openssl rsa  -in %DIRNAME%/Private/Ca.key  -pubout  -out %DIRNAME%/Private/Ca.pbc
@echo.
pause 
goto :Menu

REM *********************************************
REM *                                           *
REM *     Certificat Serveur Pour Localhost     *
REM *                                           *
REM *********************************************
REM
REM -----------------------------------------
REM   Cration d'un Nombre Pseudo-Alatoire  
REM -----------------------------------------

:SrA
cls

if EXIST %DIRNAME%\Server\Server.rnd  del %DIRNAME%\Server\Server.rnd

openssl rand  -out %DIRNAME%/Server/Server.rnd  -base64  12357

@echo.
pause 
goto :Menu

REM ------------------------------------------------
REM   Cration d'une clef prive sans mot de passe  
REM ------------------------------------------------

:SrB
cls

if EXIST %DIRNAME%\Server\Server.key  del %DIRNAME%\Server\Server.key

openssl genrsa  -out %DIRNAME%/Server/Server.key  -rand %DIRNAME%/Server/Server.rnd  4096

@echo.
pause 
goto :Menu

REM -----------------------------------------------------
REM   Cration de la demande de signature du certificat  
REM -----------------------------------------------------

:SrC
cls

if EXIST %DIRNAME%\Server\Server.csr  del %DIRNAME%\Server\Server.csr

openssl req  -new  -sha256  -key %DIRNAME%/Server/Server.key  -out %DIRNAME%/Server/Server.csr  -subj "/C=FR/ST=Aquitaine/L=Montignac/O=Artemus & Cie/CN=Localhost"

@echo.
pause 
goto :Menu

REM ------------------------------------------
REM   Cration du certificat sign par le CA  
REM ------------------------------------------

:SrD
cls

if EXIST %DIRNAME%\Server\Server.crt  del %DIRNAME%\Server\Server.crt

openssl x509  -req  -days 4383  -sha256  -in %DIRNAME%/Server/Server.csr  -CA %DIRNAME%/Cacerts/Ca.crt  -CAkey %DIRNAME%/Private/Ca.key  -CAcreateserial  -out %DIRNAME%/Server/Server.crt

@echo.
pause 
goto :Menu

REM --------------------------------------
REM   Conversion certificat PEM vers PFX    
REM --------------------------------------

:SrE
cls

if EXIST %DIRNAME%\Server\Server.pfx  del %DIRNAME%\Server\Server.pfx

openssl pkcs12  -export  -in %DIRNAME%/Server/Server.crt  -inkey %DIRNAME%/Server/Server.key  -out %DIRNAME%/Server/Server.pfx  -clcerts  -descert  -name "Client Localhost Certificate"

@echo.
pause 
goto :Menu

REM ------------------------------
REM   Visualisation de la pkcs12  
REM ------------------------------

:SrF
cls

openssl pkcs12  -info  -passout file:./%DIRNAME%/Other/Password.txt  -in %DIRNAME%/Server/Server.pfx

@echo.
pause 
goto :Menu

REM ---------------
REM   Clef Public  
REM ---------------

:SrG
cls

openssl rsa  -in %DIRNAME%/Server/Server.key  -pubout  -out %DIRNAME%/Server/Server.pbc

@echo.
pause 
goto :Menu

REM **********************
REM *                    *
REM *     Autres Cas     *
REM *                    *
REM **********************
REM
REM ----------------------------
REM   Chemin vers Apache2.2.29  
REM ----------------------------

:Cas1

set CHEMIN=f:\Wamp\bin\apache\apache2.2.29

goto :Top

REM ----------------------------
REM   Chemin vers Apache2.4.12  
REM ----------------------------

:Cas2

set CHEMIN=f:\Wamp\bin\apache\apache2.4.12

goto :Top

REM -----------------------------
REM   Transfert des certificats  
REM -----------------------------

:Cas3
cls

set DEST=%CHEMIN%\conf\certificat

if not exist "%DEST%" mkdir %DEST%

@echo.
@echo Copie de l'autorit de certification
@echo ------------------------------------
@echo.

if EXIST %DEST%\Ca\Ca.crt                 del %DEST%\Ca\Ca.crt

copy /A /Y  %DIRNAME%\Cacerts\Ca.crt      %DEST%\Ca\Ca.crt

@echo.
@echo Copie de la clef prive
@echo -----------------------
@echo.

if EXIST %DEST%\Site\Localhost.key        del %DEST%\Site\Localhost.key

copy /A /Y  %DIRNAME%\Server\Server.key   %DEST%\Site\Localhost.key

@echo.
@echo Copie du Certificat
@echo -------------------
@echo.

if EXIST %DEST%\Site\Localhost.crt        del %DEST%\Site\Localhost.crt

copy /A /Y  %DIRNAME%\Server\Server.crt   %DEST%\Site\Localhost.crt

@echo.
pause 
goto :Menu

REM -------------------------------
REM   Remise  zro du rpertoire  
REM -------------------------------

:Cas4
cls

rmdir /S /Q %DIRNAME%

mkdir .\%DIRNAME%\Cacerts
mkdir .\%DIRNAME%\Other
mkdir .\%DIRNAME%\Private
mkdir .\%DIRNAME%\Server

copy  nul      .\%DIRNAME%\Other\Index.txt
@echo 01     > .\%DIRNAME%\Other\Serial.txt
@echo toto   > .\%DIRNAME%\Other\Password.txt
@echo.
@echo Remise  zro du rpertoire 'Certificats'
@echo.
pause
goto :Top

REM ---------------------
REM   Fin du Traitement  
REM ---------------------

:Cas9

pause
exit
